<p-blockUI [target]="pnl" [blocked]="blockedPanel">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="grid">
    <div class="col-12">
        <div class="card">
            <h5 class="text-blue-500 font-bold"><i class="pi pi-users text-4xl"></i>รายการ{{title}}</h5>
            <p-table #pnl [value]="data" scrollDirection="both" [paginator]="true" [rows]="10" [scrollable]="true"
                [showCurrentPageReport]="true" styleClass="mt-3" responsiveLayout="scroll" [rowHover]="true"
                currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
                [rowsPerPageOptions]="[10,25,50]" [globalFilterFields]="['username','hospital_name','fullname']">
                <ng-template pTemplate="caption">
                    <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
                        <span class="p-input-icon-left w-full sm:w-20rem flex-order-1 sm:flex-order-0">
                            <i class="pi pi-search"></i>
                            <input pInputText type="text" (input)="onGlobalFilter(pnl, $event)" placeholder="ค้นหา"
                                class="w-full" />
                        </span>
                        <button (click)="showAddDialog()" pButton
                            class="p-button w-full sm:w-auto flex-order-0 sm:flex-order-1"
                            icon="pi pi-plus-circle" label="เพิ่มรายการ"></button>
                    </div>
                </ng-template>
                <ng-template pTemplate="header">
                    <tr>
                        <th class="text-center">ลำดับ</th>
                        <th pSortableColumn="name">รายละเอียด <p-sortIcon field="name"></p-sortIcon></th>
                        <th class="text-center" pSortableColumn="is_active" style="width:160px;">สถานะการใช้งาน <p-sortIcon field="is_active"></p-sortIcon></th>
                        <th class="text-center"></th>
                    </tr>
                </ng-template>
                <ng-template pTemplate="body" let-data let-i="rowIndex">
                    <tr>
                        <td class="text-center">{{i+1}}</td>
                        <td>{{data.description}}</td>
                        <td class="text-center" >
                            <p-tag *ngIf="data.is_active" severity="success" value="เปิดใช้งาน"></p-tag>
                            <p-tag *ngIf="!data.is_active" severity="danger" value="ปิดใช้งาน"></p-tag>
                        </td>
                        <td class="text-center">
                            <button type="button" pButton pRipple icon="pi pi-pencil"
                                class="h-1rem mr-2 p-button-warning p-button-raised" (click)="showEditDialog(data)" pTooltip="แก้ไขข้อมูล" tooltipPosition="bottom"></button>
                        </td>
                        <td class="text-center">
                            <button type="button" pButton pRipple icon="pi pi-trash"
                                class="h-1rem mr-2 p-button-danger p-button-raised" (click)="deleteData(data)" pTooltip="ลบข้อมูล" tooltipPosition="bottom"></button>
                        </td>
                    </tr>
                </ng-template>

            </p-table>
        </div>
    </div>

    <p-dialog [(visible)]="displayDialog" [style]="{ width: '50vw' }">
        <ng-template pTemplate="header">
            <h5 *ngIf="isNew">เพิ่มรายการ</h5>
            <h5 *ngIf="!isNew">แก้ไขรายการ</h5>
            <p-messages
            [(value)]="messages"
            [enableService]="false"
            [closable]="false"
        ></p-messages>
        </ng-template>
        <ng-template pTemplate="content">
            <!-- เพิ่มรายการ -->
            <div *ngIf="isNew" class="p-fluid">
                <!-- <h5>เพิ่มรายการ</h5> -->
                <div class="grid">

                    <div class="col-12 md:col-8">

                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="name" [(ngModel)]="data_name" pInputText
                                placeholder="กิจกรรมพยาบาล">
                        </div>
                    </div>
                    <div class="col-12 md:col-6">
                            <h5>สถานะการใช้งาน</h5>
                            <p-inputSwitch [(ngModel)]="data_status"></p-inputSwitch>
                    </div>
                </div>
            </div>

            <!-- แก้ไขรายการ -->
            <div *ngIf="!isNew" class="p-fluid">
                <div class="grid">
                    <div class="col-12">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="fullname" [(ngModel)]="data_name" pInputText
                                placeholder="รายละเอียด">
                        </div>
                    </div>
                    <div class="col-12 md:col-12">
                        <h5>สถานะการใช้งาน</h5>
                        <p-inputSwitch [(ngModel)]="data_status"></p-inputSwitch>
                    </div>
                </div>
            </div>
        </ng-template>
        <ng-template pTemplate="footer">
            <button *ngIf="isNew" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
                (click)="saveData()" label="เพิ่มรายการ"></button>
            <button *ngIf="!isNew" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
                (click)="updateData()" label="บันทึกแก้ไข"></button>

        </ng-template>
    </p-dialog>
</div>